## 技术心得

---

有人认为编程是一门技术活，要有一定的天赋，非天资聪慧者不能及也。其实不然，笔者虽是计算机专业出身，但工作年限并不长，对于技术这碗饭有一些心得体会，大多数人成为领域专家可能有些难度，但应付日常工作，甚至成为团队主力骨干，其实并不难。

接下来列举工作中常用的一些技术，以及如何提升自己。

### 基础知识
* 	[java](basic-knowledge/java.md)
*  	[spring](basic-knowledge/spring.md)
*	ibatis
*	Quartz
*	[HttpClient](basic-knowledge/HttpClient.md)
*	[常用的设计模式](basic-knowledge/常用的设计模式.md)


### 数据库
目前使用最多还是mysql，虽然单机性能比不上oracle，但免费开源，单机成本低且借助于分布式集群，可以有强大的输出能力。

*	[数据库连接池](data-base/数据库连接池.md)
* 	[锁机制](data-base/锁机制.md)
* 	[分库分表](data-base/分库分表.md)
* 	[id生成器](data-base/id生成器.md)
* 	[mysql中bigint、int、mediumint、smallint 和 tinyint的取值范围](data-base/bigint类型.md)
* 	master和slaver


### 中间件

* [dubbo](middle-software/dubbo.md)
* [kafka](middle-software/kafka.md)
* [zookeeper](middle-software/zookeeper.md)
* cobar
* Storm
* [Elasticsearch](middle-software/elasticsearch.md)



### 开源框架

* [Google Guava](open-source-framework/Goole-Guava.md)
* [redis](open-source-framework/redis.md)
* memcache
* [fastJson](open-source-framework/fastJson.md)
* log4J
* [commons-codec](open-source-framework/commons-codec.md)
* [commons-lang3](open-source-framework/commons-lang3.md)



### 系统架构 

* 负载均衡
* CDN
* Nginx
* [性能优化之Qps](system-architecture/性能优化之Qps.md)
* [cache相关](system-architecture/cache相关.md)
* [架构原则](system-architecture/架构原则.md)
* [经典案例](system-architecture/经典案例.md)


### web

*	[http协议](web/http协议.md)


### 运维

*	[快速排查线上问题](ops/online-question.md)
*	常用的linux命令
*	域名劫持

### 项目管理

* [程序员素养](project-management/程序员素养.md)


### 其它

*	[HTTPS 抓包工具（charles）](http://blog.vetcafe.net/2013/12/charlesproxyiphonehttps.html)
*	[一致性hash算法](other/一致性hash.md)
*	[Lombok安装](http://www.blogjava.net/fancydeepin/archive/2012/07/12/382933.html)
*	[mysql数据库binlog的增量订阅&消费组件](https://github.com/alibaba/canal)
